package org.ais_sanmarino.renardo.kodoprezento;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.IOException;

/**
 * Trovu la kodoprezenton de enigofluo (ImportStream) laŭ
 * la komenca bajt-orda markilo (BOM).
 */
public class Kodoprezento {
	private static final String APRIORA_KODOPREZENTO = "UTF-8"; // aŭ kio ajn

	public static InputStreamReader kreuLegilon(FileInputStream fis) throws IOException {
		BufferedInputStream bis = new BufferedInputStream(fis);
		bis.mark(16);
		final int b0 = bis.read();
		final int b1 = bis.read();
		final int b2 = bis.read();
		String kodoprezento;
		if (b0 == 239 && b1 == 187 && b2 == 191) { // UTF-8-BOM
			kodoprezento = "UTF-8";
		} else if (b0 == 255 && b1 == 254) { // UTF-16LE-BOM
			kodoprezento = "UTF-16LE";
		} else if (b0 == 254 && b1 == 255) { // UTF-16BE-BOM
			kodoprezento = "UTF-16BE";
		} else {
			kodoprezento = APRIORA_KODOPREZENTO;
		}

		bis.reset(); // reiru al la komenco
		final InputStreamReader legilo = new InputStreamReader(bis, kodoprezento);
		return legilo;
	}

	public static void main(String[] p) {
		testu("specimeno-utf-8.txt");
		testu("specimeno-utf-16.txt");
	}

	private static void testu(String dosieraNomo) {
		try {
			final FileInputStream fis  = new FileInputStream(dosieraNomo);
			InputStreamReader legilo = kreuLegilon(fis);
			System.out.println("Kodoprezento de " + dosieraNomo + ": " + legilo.getEncoding());
			final char[] bufro = new char[1024];
			final int longo = legilo.read(bufro);
			final String teksto = new String(bufro, 0, longo);
			System.out.println("Legita teksto: ");
			System.out.println("-----------------------------------------------------");
			System.out.println(teksto);
		} catch (IOException ioe) {
			System.out.println("dosiero ne trovita: " + dosieraNomo);
		}
		System.out.println("=====================================================");
	}
}
